const fs = require('fs-extra');
const path = require('path');

const testNodeModules = path.join(__dirname, '/../test/node_modules');
fs.removeSync(testNodeModules);
fs.mkdirSync(testNodeModules);
fs.symlinkSync(path.join(__dirname, '/..'), path.join(testNodeModules, 'apostrophe'), 'dir');

const extras = path.join(__dirname, '../test/extra_node_modules');
const dirs = fs.existsSync(extras) ? fs.readdirSync(extras) : [];
for (const dir of dirs) {
  fs.symlinkSync(path.join(extras, dir), path.join(testNodeModules, dir), 'dir');
}

// Need a "project level" package.json for functionality that checks
// whether packages in node_modules are project level or not

const packageJson = path.join(__dirname, '/../test/package.json');
// Remove it first, in case it's the old-style symlink to the main package.json,
// which would break
fs.removeSync(packageJson);
const packageJsonInfo = {
  name: 'test',
  dependencies: {
    apostrophe: '^3.0.0'
  },
  devDependencies: {
    'test-bundle': '1.0.0'
  }
};
for (const dir of dirs) {
  packageJsonInfo.dependencies[dir] = '1.0.0';
}

fs.writeFileSync(packageJson, JSON.stringify(packageJsonInfo, null, '  '));

module.exports = require('./util.js');
